/*
 * This file is generated by jOOQ.
 */
package de.ship.db.tables;


import de.ship.db.CommonDd;
import de.ship.db.enums.EnumIsocode;
import de.ship.db.tables.records.VCoreLanguageRecord;

import java.util.Collection;

import org.jooq.Condition;
import org.jooq.Field;
import org.jooq.Name;
import org.jooq.PlainSQL;
import org.jooq.QueryPart;
import org.jooq.SQL;
import org.jooq.Schema;
import org.jooq.Select;
import org.jooq.Stringly;
import org.jooq.Table;
import org.jooq.TableField;
import org.jooq.TableOptions;
import org.jooq.impl.DSL;
import org.jooq.impl.SQLDataType;
import org.jooq.impl.TableImpl;


/**
 * This class is generated by jOOQ.
 */
@SuppressWarnings({ "all", "unchecked", "rawtypes" })
public class VCoreLanguage extends TableImpl<VCoreLanguageRecord> {

    private static final long serialVersionUID = 1L;

    /**
     * The reference instance of <code>common_dd.v_core_language</code>
     */
    public static final VCoreLanguage V_CORE_LANGUAGE = new VCoreLanguage();

    /**
     * The class holding records for this type
     */
    @Override
    public Class<VCoreLanguageRecord> getRecordType() {
        return VCoreLanguageRecord.class;
    }

    /**
     * The column <code>common_dd.v_core_language.lang_key</code>.
     */
    public final TableField<VCoreLanguageRecord, String> LANG_KEY = createField(DSL.name("lang_key"), SQLDataType.CLOB, this, "");

    /**
     * The column <code>common_dd.v_core_language.lang_isocode</code>.
     */
    public final TableField<VCoreLanguageRecord, EnumIsocode> LANG_ISOCODE = createField(DSL.name("lang_isocode"), SQLDataType.VARCHAR.asEnumDataType(EnumIsocode.class), this, "");

    /**
     * The column <code>common_dd.v_core_language.lang_value</code>.
     */
    public final TableField<VCoreLanguageRecord, String> LANG_VALUE = createField(DSL.name("lang_value"), SQLDataType.CLOB, this, "");

    private VCoreLanguage(Name alias, Table<VCoreLanguageRecord> aliased) {
        this(alias, aliased, (Field<?>[]) null, null);
    }

    private VCoreLanguage(Name alias, Table<VCoreLanguageRecord> aliased, Field<?>[] parameters, Condition where) {
        super(alias, null, aliased, parameters, DSL.comment(""), TableOptions.view("""
        create view "v_core_language" as  SELECT l.translation_key AS lang_key,
         t.isocode AS lang_isocode,
         t.value AS lang_value
        FROM (common_dd.t_core_translation t
          LEFT JOIN common_dd.t_core_translation_key l ON ((l.translation_key = t.fk_trans_key)));
        """), where);
    }

    /**
     * Create an aliased <code>common_dd.v_core_language</code> table reference
     */
    public VCoreLanguage(String alias) {
        this(DSL.name(alias), V_CORE_LANGUAGE);
    }

    /**
     * Create an aliased <code>common_dd.v_core_language</code> table reference
     */
    public VCoreLanguage(Name alias) {
        this(alias, V_CORE_LANGUAGE);
    }

    /**
     * Create a <code>common_dd.v_core_language</code> table reference
     */
    public VCoreLanguage() {
        this(DSL.name("v_core_language"), null);
    }

    @Override
    public Schema getSchema() {
        return aliased() ? null : CommonDd.COMMON_DD;
    }

    @Override
    public VCoreLanguage as(String alias) {
        return new VCoreLanguage(DSL.name(alias), this);
    }

    @Override
    public VCoreLanguage as(Name alias) {
        return new VCoreLanguage(alias, this);
    }

    @Override
    public VCoreLanguage as(Table<?> alias) {
        return new VCoreLanguage(alias.getQualifiedName(), this);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLanguage rename(String name) {
        return new VCoreLanguage(DSL.name(name), null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLanguage rename(Name name) {
        return new VCoreLanguage(name, null);
    }

    /**
     * Rename this table
     */
    @Override
    public VCoreLanguage rename(Table<?> name) {
        return new VCoreLanguage(name.getQualifiedName(), null);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguage where(Condition condition) {
        return new VCoreLanguage(getQualifiedName(), aliased() ? this : null, null, condition);
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguage where(Collection<? extends Condition> conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguage where(Condition... conditions) {
        return where(DSL.and(conditions));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguage where(Field<Boolean> condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguage where(SQL condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguage where(@Stringly.SQL String condition) {
        return where(DSL.condition(condition));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguage where(@Stringly.SQL String condition, Object... binds) {
        return where(DSL.condition(condition, binds));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    @PlainSQL
    public VCoreLanguage where(@Stringly.SQL String condition, QueryPart... parts) {
        return where(DSL.condition(condition, parts));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguage whereExists(Select<?> select) {
        return where(DSL.exists(select));
    }

    /**
     * Create an inline derived table from this table
     */
    @Override
    public VCoreLanguage whereNotExists(Select<?> select) {
        return where(DSL.notExists(select));
    }
}
